<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<!-- Default Primary Audio HAL Module Audio Policy Configuration include flie -->
<module name="primary" halVersion="2.0">
    <attachedDevices>
        <item>Speaker</item>
        <item>Earpiece</item>
        <item>Built-In Mic</item>
        <item>Fm Record Device</item>
        <item>Telephony Rx</item>
        <item>Telephony Tx</item>
    </attachedDevices>
    <defaultOutputDevice>Speaker</defaultOutputDevice>
    <mixPorts>
        <mixPort name="primary output" role="source" flags="AUDIO_OUTPUT_FLAG_PRIMARY">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                             samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>

        <mixPort name="compressed_offload" role="source"
                         flags="AUDIO_OUTPUT_FLAG_DIRECT AUDIO_OUTPUT_FLAG_COMPRESS_OFFLOAD AUDIO_OUTPUT_FLAG_NON_BLOCKING AUDIO_OUTPUT_FLAG_GAPLESS_OFFLOAD">
        </mixPort>
        <mixPort name="fast" role="source"
                flags="AUDIO_OUTPUT_FLAG_FAST">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>
        <mixPort name="primary input" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                             samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                             channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="recognition input" role="sink" flags="AUDIO_INPUT_FLAG_FAST">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                             samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                             channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="fm input" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                             samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                             channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="voice_tx" role="source" flags="AUDIO_OUTPUT_FLAG_INCALL_MUSIC">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000 32000 48000" channelMasks="AUDIO_CHANNEL_OUT_MONO AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>
        <mixPort name="voip_rx" role="source"
                 flags="AUDIO_OUTPUT_FLAG_VOIP_RX">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                   samplingRates="8000 16000 32000 44100 48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO AUDIO_CHANNEL_OUT_MONO"/>
        </mixPort>
    </mixPorts>
    <devicePorts>
        <!-- Output devices declaration  i.e. Sink DEVICE PORT -->
        <devicePort tagName="Earpiece" type="AUDIO_DEVICE_OUT_EARPIECE" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                            samplingRates="48000" channelMasks="AUDIO_CHANNEL_IN_MONO"/>
        </devicePort>
        <devicePort tagName="Speaker" role="sink" type="AUDIO_DEVICE_OUT_SPEAKER">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </devicePort>
        <devicePort tagName="Wired Headset" type="AUDIO_DEVICE_OUT_WIRED_HEADSET" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </devicePort>
        <devicePort tagName="Wired Headphones" type="AUDIO_DEVICE_OUT_WIRED_HEADPHONE" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </devicePort>
        <devicePort tagName="BT SCO" type="AUDIO_DEVICE_OUT_BLUETOOTH_SCO" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_OUT_MONO"/>
        </devicePort>
        <devicePort tagName="BT SCO Headset" type="AUDIO_DEVICE_OUT_BLUETOOTH_SCO_HEADSET" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_OUT_MONO"/>
        </devicePort>
        <devicePort tagName="BT SCO Car Kit" type="AUDIO_DEVICE_OUT_BLUETOOTH_SCO_CARKIT" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_OUT_MONO"/>
        </devicePort>
        <devicePort tagName="Built-In Mic" type="AUDIO_DEVICE_IN_BUILTIN_MIC" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </devicePort>
        
        <devicePort tagName="Wired Headset Mic" type="AUDIO_DEVICE_IN_WIRED_HEADSET" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </devicePort>
        <devicePort tagName="BT SCO Headset Mic" type="AUDIO_DEVICE_IN_BLUETOOTH_SCO_HEADSET" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_IN_MONO"/>
        </devicePort>
        <devicePort tagName="Telephony Rx" type="AUDIO_DEVICE_IN_TELEPHONY_RX" role="source">
        </devicePort>
        <devicePort tagName="Telephony Tx" type="AUDIO_DEVICE_OUT_TELEPHONY_TX" role="sink">
        </devicePort>
        <devicePort tagName="Fm Record Device" type="AUDIO_DEVICE_IN_FM_TUNER" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_IN_MONO"/>
        </devicePort>

        <devicePort tagName="USB Device Out" type="AUDIO_DEVICE_OUT_USB_DEVICE" role="sink"/>
        <devicePort tagName="USB Headset Out" type="AUDIO_DEVICE_OUT_USB_HEADSET" role="sink"/>
        <devicePort tagName="USB Device In" type="AUDIO_DEVICE_IN_USB_DEVICE" role="source"/>
        <devicePort tagName="USB Headset In" type="AUDIO_DEVICE_IN_USB_HEADSET" role="source"/>
    </devicePorts>
    <!-- route declaration  i.e. list all available sources for a given sink -->
    <routes>
        <route type="mix" sink="Earpiece"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="Speaker"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="Wired Headset"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="Wired Headphones"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="BT SCO"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="BT SCO Headset"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="BT SCO Car Kit"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="primary input"
               sources="Built-In Mic,Wired Headset Mic,BT SCO Headset Mic,USB Device In,USB Headset In,Telephony Rx"/>
        <route type="mix" sink="recognition input"
               sources="Built-In Mic,Wired Headset Mic,USB Headset In,USB Device In"/>
        <route type="mix" sink="fm input"
               sources="Fm Record Device"/>
        <route type="mix" sink="USB Device Out"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="USB Headset Out"
               sources="primary output,fast,voip_rx"/>
        <route type="mix" sink="Telephony Tx"
               sources="voice_tx"/>
    </routes>
</module>
<!-- ZOVERLAY_TAG_SINGLE_MIC -->